<id>
Last Login Mod
</id>

<version>
 1.4 (SP1.1 ONLY)
</version>

<mod info>
This Mod stores the last login time of each user in their .dat file and displays it in their profile when viewed. The files for this version (V1.4) are nearly identical to Version 1.3. However, the search location in the files where the changes are made is different for Yabb Gold SP1 than for Yabb Gold SP1.1. This file is for use with the LastVisit mod. Location changes made by Tom Gnirrep with permission of the author. Mail to tgnirrep@bellatlantic.net  
</mod info>

<author>
Monty Burns
</author>

<homepage>
mailto:abpremier@beer.com
</homepage>

<Edit file>
Sources/AdminEdit.pl
</Edit file>

<Search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'478'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_limits" size="45" value="$userpic_limits"></td>
</Search for>

<Add after>
<!--### Last Login Mod - Admin Settings - Begin
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <hr class="hr" size="1" width="100%"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$lltxt{'1'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="lloginline" size="5" value="$lloginline"></td>
<!--### Last Login Mod - Admin Settings - End
</Add after>

<Search for>
	$use_flock = $FORM{'use_flock'} || 0;
</Search for>

<Add after>
### Last Login Mod - Default Value - Begin
	$lloginline = $FORM{'lloginline'} || 25;
### Last Login Mod - Default Value - End
</Add after>

<Search for>
########## File Locking ##########
</Search for>

<Add before>
########## Last Login Settings ##########

\$lloginline = $lloginline;                                           # The line in <username>.dat on which the last login date/time appears (in the code used, 1 is automatically subtracted from this value for the physical line in the array, as the array starts at 0 as opposed to 1)
                                                                      # This number MUST be GREATER than 20 by default.

</Add before>

<Edit file>
Sources/LogInOut.pl
</Edit file>

<Search for>
	&LoadUserSettings;
	if ($maintenance && $settings[7] ne 'Administrator') {$username = 'Guest'; &fatal_error($txt{'774'});}
	&WriteLog;
	&redirectinternal;
</Search for>

<Replace>
	&LoadUserSettings;
	if ($maintenance && $settings[7] ne 'Administrator') {$username = 'Guest'; &fatal_error($txt{'774'});}
	&WriteLog;
	
### Last Login Mod - Record Last Login Time - Begin	
	my @temparr = ($username, "");
	&WriteLastLogin(@temparr);
### Last Login Mod - Record Last Login Time - End	
	
	&redirectinternal;
</Replace>

<Edit file>
Sources/Profile.pl
</Edit file>

<Search for>
	$dr = $memsettings[14] ? $memsettings[14] : $txt{'470'};
</Search for>

<Add after>
### Last Login Mod - Get Current Value - Begin
	$lltime = $memsettings[($lloginline-1)] ? $memsettings[($lloginline-1)] : $txt{'470'};
### Last Login Mod - Get Current Value - End	
</Add after>

<Search for>
        <td width="320"><font size=2><b>$txt{'233'}:</b><BR>
        <font size="1">$txt{'421'}</font><BR><BR></td>
        <td><input type="text" name="dr" size="20" value="$dr"><BR><BR></td>
      </tr>~;
</Search for>

<Replace>
        <td width="320"><font size=2><b>$txt{'233'}:</b><BR>
        <font size="1">$txt{'421'}</font><BR><BR></td>
        <td><input type="text" name="dr" size="20" value="$dr"><BR><BR></td>

<!--### Last Login Mod - Allow Editing in Profile for Admins - Begin -->
      </tr><tr>
        <td width="320"><font size=2><b>$lltxt{'2'}:</b><BR>
        <font size="1">$txt{'421'}</font><BR><BR></td>
        <td><input type="text" name="lltime" size="20" value="$lltime"><BR><BR></td>
<!--### Last Login Mod - Allow Editing in Profile for Admins - End -->

      </tr>~;
</Replace>

<Search for>
		if($settings[7] ne "Administrator") { $member{'dr'} = $settings[14]; }
</Search for>

<Replace>
		if($settings[7] ne "Administrator") { 
			$member{'dr'} = $settings[14];
			
### Last Login Mod - Get Last Login Time - Begin
			$member{'lltime'} = $settings[($lloginline-1)];
### Last Login Mod - Get Last Login Time - End			

		}
</Replace>

<Search for>
	if($newpassemail) {
</Search for>

<Add before>
### Last Login Mod - Write Time to File - Begin
		my @temparr = ($member{'username'}, $member{'lltime'});
		&WriteLastLogin(@temparr);
### Last Login Mod - Write Time to File - End
</Add before>

<Search for>
	$dr = "";
	if ($memsettings[14] eq "") { $dr = "$txt{'470'}"; }
	else { $dr = "$memsettings[14]"; $dr = &timeformat($dr); }
</Search for>

<Add after>
### Last Login Mod - Format Time - Begin
	$lltime = "";
	if ($memsettings[($lloginline-1)] eq "") { $lltime = "$txt{'470'}"; }
	else { $lltime = "$memsettings[($lloginline-1)]"; $lltime = &timeformat($lltime); }
### Last Login Mod - Format Time - End
</Add after>

<Search for>
      </tr><tr>
        <td><font size=2><b>$txt{'233'}: </b></font></td>
        <td><font size=2>$dr</font></td>
</Search for>

<Add after>
<!--### Last Login Mod - Display in Profile - Begin -->
      </tr><tr>
        <td><font size=2><b>$lltxt{'2'}: </b></font></td>
        <td><font size=2>$lltime</font></td>
<!--### Last Login Mod - Display in Profile - End -->        
       
</Add after>

<Edit file>
Sources/Subs.pl
</Edit file>

<Search for>
sub WriteLog {
	my($curentry, $name);
	my $field = $username;
	if($field eq "Guest") { $field = "$user_ip"; }
</Search for>

<Add before>
### Last Login Mod - Subroutine - Begin
sub WriteLastLogin ($) {
	my( $userfilehandle, $userlastlogin ) = @_;

# If no user's name is passed, set <userfilehandle> to the current user
# Fixes up where administrators are modifying user's profiles
	if ($userfilehandle eq "") { 
		$userfilehandle = $username;
	}

# Open the existing user file and read it into an array
	fopen(FILE, "< $memberdir/$userfilehandle.dat");
	chomp( my @memsettings = <FILE> );
	fclose(FILE);
	
	$count = 0;
	foreach (@memsettings) {
		$count++;
	}
	
# If there are fewer lines in the profile than the line number for storing the 
# last login, pad the array with blank lines entires
	while ($count < ($lloginline-1)) { 
		$count++;
		$memsettings[$count] = "";
	}
			
# If there is no Last Login info passed to this sub, record the current date/time
# Otherwise, use the current info
	if ($userlastlogin eq "") {

# Assign the current date to the appropriate location in the array
# Uses: ($lloginline-1) to compensate for the array starting at 0 instead of 1
		$memsettings[($lloginline-1)] = $date;
	} else {
		$memsettings[($lloginline-1)] = $userlastlogin;
	}

	fopen(FILE, "> $memberdir/$userfilehandle.dat"); 
            foreach (@memsettings) { 
            print FILE "$_\n";
} 
fclose(FILE);
}
### Last Login Mod - Subroutine - End
</Add before>

<Edit file>
Settings.pl
</Edit file>

<Search for>
########## File Locking ##########
</Search for>

<Add before>
########## Last Login Settings ##########

$lloginline = 25;                                                     # The line in <username>.dat on which the last login date/time appears (in the code used, 1 is automatically subtracted from this value for the physical line in the array, as the array starts at 0 as opposed to 1)
                                                                      # This number MUST be GREATER than 20 by default.

</Add before>

<Edit file>
english.lng
</Edit file>

<Search for>
$yycopyright = qq~<a href="$boardurl/YaBB.$yyext"><font size="1">$mbname</font></a> &#187; <font size="1">Powered by</font> <a href="http://www.yabbforum.com"><font size="1">YaBB $YaBBversion</font></a><font size="1">!<BR>\nYaBB  2000-2002, </font><a href="http://www.xnull.com"><font size="1">Xnull</font></a><font size="1">. All Rights Reserved.</font>~;
</Search for>

<Add before>
### Last Login Mod - Text - Begin
keys(%lltxt) = 2;
$lltxt{'1'} = "Line # to store last visit info (must be higher than 20)";
$lltxt{'2'} = "Last Visit";
### Last Login Mod - Text - End
</Add before>